#include <bits/stdc++.h>
#include "code.h"
using namespace std;

using ll = int;
namespace {
    static vector<pair<int, int>> points;
    static vector<int> p;
    static int n;
    static int q;
    static int qt;
}
vector<pair<int, int>> ZapisiTacke(int n)
{
    ll i;
    vector<pair<int,int>> tacke(n+1);
    tacke[1]={1,1};
    for(i=2;i<=n;i++)
    {
        tacke[i]={2,i};
    }
    return tacke;
}
vector<int> Resi(int n, int q)
{
    ll i,j,k,pocetna,res;
    i=1;
    j=2;
    k=3;
    pocetna=-1;
    res=Pitaj(i,j,k);
    if(res==0)
    {
        for(k=4;k<=n;k++)
        {
            if(Pitaj(i,j,k)!=0)
            {
                pocetna=k;
            }
        }
    }
    else
    {
        if(Pitaj(i,j,4)==0)
        {
            pocetna=k;
        }
        else if(Pitaj(i,k,4)==0)
        {
            pocetna=j;
        }
        else
        {
            pocetna=i;
        }
    }
    vector<pair<int,int>>resenje(n);
    vector<int>pobede(n),resu(n+1);
    vector<vector<bool>>vecdobio(n,vector<bool>(n,false));

    pobede[pocetna-1]=-1;
    resu[pocetna-1]=1;
    for(i=0;i<n;i++)
    {
        if(pocetna==i+1)
        {
            continue;
        }
        vector<int>dobio,izgubio;
        for(j=i+1;j<n;j++)
        {
            if(j+1==pocetna)
            {
                continue;
            }
            if(vecdobio[i][j])
            {
                pobede[i]++;
                continue;
            }
            if(vecdobio[j][i])
            {
                pobede[j]++;
                continue;
            }
            res=Pitaj(pocetna,i+1,j+1);
            if(res==-1)
            {
                pobede[i]++;
                dobio.push_back(j);
            }
            else
            {
                pobede[j]++;
                izgubio.push_back(j);
            }
        }
        for(auto &x:dobio)
        {
            for(auto &y:izgubio)
            {
                vecdobio[y][x]=true;
            }
        }
    }
    for(i=0;i<n;i++)
    {
        if(i==pocetna-1)
        {
            continue;
        }
        resu[i]=pobede[i]+2;
    }
    for(i=n;i>0;i--)
    {
        resu[i]=resu[i-1];
    }
    return resu;
}